#include "libgccvb.h"

#include "vb\notes.h"
#include "vb\voices.h"
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual sounds


#include "pathwaychar.h"
#include "pathwaymap.h"
#include "homescreenchar.h"
#include "homescreenmap.h"
#include "quincychar.h"
#include "quincymap.h"


#include "blankchar.h"
#include "blankmap.h"
#include "chrbgchar.h"
#include "chrbgmap.h"
#include "chrfgchar.h"
#include "chrfgmap.h"
#include "intro1char.h"
#include "intro1map.h"
#include "intro2char.h"
#include "intro2map.h"
#include "intro3char.h"
#include "intro3map.h"
#include "p64font.h"
#include "tspineapplechar.h"
#include "tspineapplefrontchar.h"
#include "tspineapplefrontmap.h"
#include "tspineapplemap.h"
#include "tspineapplechar.h"
#include "tssmallpineapplechar.h"
#include "tssmallpineapplemap.h"
#include "vbtestchar.h"
#include "vbtestmap.h"

#define kBrightness 32  
unsigned char optiony=143, sel_pressed=0, notecounter=0, start_pressed=0, option_y_pos=1;
unsigned char quincyanimtimer=0, quincycutx=0, quincycuty=0, left=0, right=0, up=0, down=0;
int quincyx=340, quincyy=140, screen=0, f, e, d, g, h;

u8 instrument1=1, instrument2=2, instrument3=3;

HWORD getBGMapChar(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7ff);
		}

HWORD getBGMapChar2(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7fe);
		}

HWORD getBGMapChar3(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7fd);
		}

HWORD getBGMapChar4(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7fc);
		}

HWORD getBGMapChar5(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7fb);
		}

HWORD getBGMapChar6(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7fa);
		}

HWORD getBGMapChar7(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f9);
		}

HWORD getBGMapChar8(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f8);
		}

HWORD getBGMapChar9(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f7);
		}

HWORD getBGMapChar10(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f6);
		}

HWORD getBGMapChar11(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f5);
		}

HWORD getBGMapChar12(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f4);
		}

HWORD getBGMapChar13(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f3);
		}

HWORD getBGMapChar14(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f2);
		}

HWORD getBGMapChar15(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f1);
		}

HWORD getBGMapChar16(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7f0);
		}

HWORD getBGMapChar17(bgmap, x, y)
    	{ 	
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7ef);
		}

void WaitForVIP () {

  while(!(VIP_REGS[INTPND] & XPEND)); 
  VIP_REGS[INTCLR] = XPEND;
}

void SetBrightness (u16 Brightness)
{
  // Sets the brightness.
  VIP_REGS[BRTA] = Brightness;
  VIP_REGS[BRTB] = Brightness << 1;
  VIP_REGS[BRTC] = Brightness;
}


void FadeIn ()
{
  u16 i;
   
  for(i = 0; i <= kBrightness; i += 1 /* change the 2 to adjust the speed */)
  {
    WaitForVIP();
    SetBrightness(i);
  }

}

void FadeOut ()
{
  u16 i;

  for(i = kBrightness; i > 1; i -= 1 /* same here */)
  {
    WaitForVIP();  
    SetBrightness(i);
  }

  SetBrightness(0);  // Ensure it's pitch black.
}


void instrumentchange(){
switch(instrument1)
	{
		case 1:
		copymem((void*)WAVEDATA1, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA1, (void*)PIANO, 128);
		break;
	
		case 3:
		copymem((void*)WAVEDATA1, (void*)VIOLIN, 128);
		break;
		
		default:
		break;		
		}
		
	switch(instrument2)
	{
		case 1:
		copymem((void*)WAVEDATA2, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA2, (void*)PIANO, 128);
		break;
		
		case 3:
		copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);
		break;
		
		default:
		break;
		}		

	switch(instrument3)
	{
		case 1:
		copymem((void*)WAVEDATA3, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA3, (void*)PIANO, 128);
		break;
		
		case 3:
		copymem((void*)WAVEDATA3, (void*)VIOLIN, 128);
		break;
		
		default:
		break;		
		}	
}

#define kBrightness 32  // You might want to make this a variable or a parameter to the fading functions.




int main(){	
	vbDisplayOn();
	vbDisplayShow();


	
	copymem((void*)CharSeg3, (void*)P64FONT, 8192);	
	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
    vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	
		vbTextOut(0, 10, 1,"                                ");
		vbTextOut(0, 10, 2,"                                ");	
		vbTextOut(0, 10, 3,"                                ");
		vbTextOut(0, 10, 4,"                                ");		
		vbTextOut(0, 10, 5,"                                ");
		vbTextOut(0, 10, 6,"                                ");		
	
		vbTextOut(0, 19, 10,"IMPORTANT:");
		vbTextOut(0, 13, 12,"IGNORE THE INSTRUCTION");
		vbTextOut(0, 12, 14,"AND PRECAUTION BOOKLETS.");
		vbTextOut(0, 15, 16,"JUST PLAY THE GAME.");	
	

   	FadeIn();
  //INSTRUCTIONS
  	StopAllSounds();

	while (!(vbReadPad()&K_STA)) {

	}
	while (vbReadPad()&K_STA); //Don't continue until start is released





	FadeOut();
	
	
	copymem((void*)CharSeg1, (void*)VBTESTCHAR, 256*16);
    copymem((void*)BGMap(1), (void*)VBTESTMAP, 512*16);

    vbSetWorld(31, WRLD_LON|1, 0, 0, 0, 0, 0, 0, 384, 224);
    vbSetWorld(30, WRLD_RON|1, 0, 0, 0, 0, 0, 224, 384, 224);
	
	

	
	FadeIn();

  //VB calibration screen
	while (!(vbReadPad()&K_STA)) {


	}
	
	FadeOut();
	InitSound();
	
// chris's chrappy chreations screen
	SND_REGS[0].SxLRV = 0x77;         // Left/right speaker volume.
	SND_REGS[1].SxLRV = 0xaa;         // Left/right speaker volume.
	SND_REGS[2].SxLRV = 0xff;         // Left/right speaker volume.	


    vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
    vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

    copymem((void*)CharSeg0, (void*)CHRBGCHAR, 512*16);
    copymem((void*)BGMap(0), (void*)CHRBGMAP, 512*16);

    copymem((void*)CharSeg1, (void*)CHRFGCHAR, 512*16);
    copymem((void*)BGMap(1), (void*)CHRFGMAP, 512*16);

	VIP_REGS[GPLT1]=0x24;
	PlaySound(chrappy1), PlaySound(chrappy2), PlaySound(chrappy3);
	vbFXFadeIn(1);


	while(notecounter<201){
	DoSounds();
	vbWaitFrame(0);
	notecounter++;


	}
	

	//StopAllSounds();	
	FadeOut();
	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	copymem((void*)CharSeg0, (void*)TSPINEAPPLECHAR, 512*16);  
	copymem((void*)BGMap(0), (void*)TSPINEAPPLEMAP, 512*16); 		
	
	copymem((void*)CharSeg1, (void*)TSPINEAPPLEFRONTCHAR, 512*16);  
	copymem((void*)BGMap(1), (void*)TSPINEAPPLEFRONTMAP, 512*16); 		
	
	copymem((void*)CharSeg2, (void*)TSSMALLPINEAPPLECHAR, 256*16);  
	copymem((void*)BGMap(2), (void*)TSSMALLPINEAPPLEMAP, 256*16); 
	
	vbSetWorld(29, WRLD_ON|1, 0, 3, 0, 0, 0, 0, 384, 224);	
	vbSetWorld(30, WRLD_ON|2, 120, 0, optiony, 0, 0, 0, 8, 16);		
	vbSetWorld(31, WRLD_ON, 0, -3, 0, 0, 0, 0, 384, 224);		
	

	
	instrumentchange();
	

	
	FadeIn();
	
	PlaySound(titlesongmosttreble);
	PlaySound(titlesongtreble);
	PlaySound(titlesongbass);	
	

	
	
	


	
	
	while(start_pressed<2) {
	
	
	if((vbReadPad()&K_STA) && (start_pressed==0)) start_pressed=1;
	if((!(vbReadPad()&K_STA) && (start_pressed==1))) start_pressed=2;	
	
	if((vbReadPad()&K_SEL) && (sel_pressed==0)) sel_pressed=1;
	if((!(vbReadPad()&K_SEL) && (sel_pressed==1))) sel_pressed=2, option_y_pos++; 	
	
	if (option_y_pos==3) option_y_pos=1;
	if (option_y_pos==1) optiony=143;
	if (option_y_pos==2) optiony=165;
	if (sel_pressed==2) vbSetWorld(30, WRLD_ON|2, 120, 0, optiony, 0, 0, 0, 8, 16), sel_pressed=0;
	
	DoSounds();
	}
	StopAllSounds();
	
	PlaySound(introtreble);
	PlaySound(introbass);		
	
	FadeOut();

	copymem((void*)CharSeg0, (void*)BLANKCHAR, 512*16);  
	copymem((void*)BGMap(0), (void*)BLANKMAP, 512*16); 	

	copymem((void*)CharSeg1, (void*)INTRO1CHAR, 512*16);  
	copymem((void*)BGMap(1), (void*)INTRO1MAP, 512*16); 

		vbTextOut(0, 10, 1,"ONE DAY QUINCY WENT TO THE      ");
		vbTextOut(0, 10, 2,"GROCERY STORE TO GET A          ");
		vbTextOut(0, 10, 3,"PINEAPPLE BUT THERE WERE NO     ");
		vbTextOut(0, 10, 4,"PINEAPPLES TO GET.              ");	
		vbTextOut(0, 10, 5,"                                ");
		vbTextOut(0, 10, 6,"                                ");		
		
	vbSetWorld(31, WRLD_ON|1, 0, 3, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON, 0, 3, 0, 0, 0, 0, 384, 224);

	FadeIn();

	while((start_pressed>1) && (start_pressed<4)) {
	if((vbReadPad()&K_STA) && (start_pressed==2)) start_pressed=3;
	if((!(vbReadPad()&K_STA) && (start_pressed==3))) start_pressed=4;	
	DoSounds();
	}

	copymem((void*)CharSeg1, (void*)INTRO2CHAR, 512*16);  
	copymem((void*)BGMap(1), (void*)INTRO2MAP, 512*16); 

		vbTextOut(0, 10, 1,"                 SO HE ASKED THE");
		vbTextOut(0, 10, 2,"                 PRODUCE MANAGER");
		vbTextOut(0, 10, 3,"                 BUT SHE DID NOT");
		vbTextOut(0, 10, 4,"                 EVEN KNOW WHAT ");
		vbTextOut(0, 10, 5,"                 THEY WERE... OR");	
		vbTextOut(0, 10, 6,"                 SO SHE CLAIMED.");
		
	vbSetWorld(31, WRLD_ON|1, 0, 3, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON, 0, 3, 0, 0, 0, 0, 384, 224);

	
	while((start_pressed>3) && (start_pressed<6)) {
	if((vbReadPad()&K_STA) && (start_pressed==4)) start_pressed=5;
	if((!(vbReadPad()&K_STA) && (start_pressed==5))) start_pressed=6;	
	DoSounds();
	}


	//DoSounds();
	copymem((void*)CharSeg1, (void*)INTRO3CHAR, 512*16);  
	copymem((void*)BGMap(1), (void*)INTRO3MAP, 512*16); 

		vbTextOut(0, 10, 1,"AT EVERY SINGLE GROCERY STORE    ");
		vbTextOut(0, 10, 2,"HE WENT TO THERE WERE NO         ");
		vbTextOut(0, 10, 3,"PINEAPPLES. SO QUINCY BEGAN HIS  ");
		vbTextOut(0, 10, 4,"SEARCH FOR ANY PINEAPPLE.        ");
		vbTextOut(0, 10, 5,"                                 ");
		vbTextOut(0, 10, 6,"                                 ");		
		
	vbSetWorld(31, WRLD_ON|1, 0, 3, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON, 0, 3, 0, 0, 0, 0, 384, 224);

	
	while((start_pressed>5) && (start_pressed<8)) {
	if((vbReadPad()&K_STA) && (start_pressed==6)) start_pressed=7;
	if((!(vbReadPad()&K_STA) && (start_pressed==7))) start_pressed=8;	
	DoSounds();
	}


//main screen

	StopAllSounds();
	
	
	
	FadeOut();
	
	copymem((void*)CharSeg0, (void*)QUINCYCHAR, 256*16);  
	copymem((void*)BGMap(0), (void*)QUINCYMAP, 256*16); 	
	
	
	copymem((void*)CharSeg1, (void*)HOMESCREENCHAR, 256*16);  
	copymem((void*)BGMap(1), (void*)HOMESCREENMAP, 256*16); 	
	
	copymem((void*)CharSeg2, (void*)PATHWAYCHAR, 512*16);  
	copymem((void*)BGMap(2), (void*)PATHWAYMAP, 512*16); 	
	

	vbSetWorld(31, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 384, 224);

	
	quincycutx=16, screen=1, left=0, right=1;
	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	
	vbSetWorld(29, WRLD_ON, quincyx, -2, quincyy, quincycutx, 0, 0, 14, 32);	
	FadeIn();
	
	while(screen==1){
	
	

	
	


	if ((quincyanimtimer==3) && (left==1)) quincyanimtimer=4, quincyx=quincyx-2;
	if ((quincyanimtimer==3) && (right==1)) quincyanimtimer=4, quincyx=quincyx+2;	
	

	if ((quincyanimtimer==3) && (up==1)) quincyanimtimer=4, quincyy=quincyy-2;
	if ((quincyanimtimer==3) && (down==1)) quincyanimtimer=4, quincyy=quincyy+2;		

	if (quincyanimtimer>3) quincycutx=quincycutx+16, quincyanimtimer=0;
	
	//left and right are switched for the next 3 lines. I got confused.
	if (quincycutx>48) quincycutx=quincycutx-32;
	if ((left>0) && (quincycutx<32)) quincycutx=48;	
	if ((right>0) && (quincycutx>16)) quincycutx=0;	
	

	if((vbReadPad()&(K_LD)) && (left==1)) left=2;
	if((vbReadPad()&(K_LD)) && (right==1)) right=2;

	if((vbReadPad()&(K_LU)) && (left==1)) left=2;
	if((vbReadPad()&(K_LU)) && (right==1)) right=2;


	
	
	
	f=7;
	
	
    if (getBGMapChar(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar2(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar3(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar4(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar5(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar6(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar7(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar8(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
    if (getBGMapChar9(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar10(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar11(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar12(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar13(1, (quincyx/8)+1, (quincyy/8)+4)==512) f=8;

	
    if (getBGMapChar(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar2(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar3(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar4(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar5(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar6(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar7(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar8(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
    if (getBGMapChar9(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar10(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar11(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar12(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar13(1, (quincyx/8)+0, (quincyy/8)+1)==512) f=8;



    if (getBGMapChar(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar2(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar3(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar4(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar5(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar7(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar8(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
    if (getBGMapChar9(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar10(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar11(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	if (getBGMapChar12(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;	
    if (getBGMapChar13(1, (quincyx/8)+1, (quincyy/8)+1)==512) f=8;
	
	
    if (getBGMapChar(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar2(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar3(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar4(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar5(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar6(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar7(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar8(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
    if (getBGMapChar9(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar10(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar11(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	if (getBGMapChar12(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;	
    if (getBGMapChar13(1, (quincyx/8)+0, (quincyy/8)+4)==512) f=8;
	
	// if f=8 then a collision has happened.
	

	if((vbReadPad()&(K_LD)) && (vbReadPad()&(K_LL))) quincyanimtimer=0;
	if((vbReadPad()&(K_LD)) && (vbReadPad()&(K_LR))) quincyanimtimer=0;	
	if((vbReadPad()&(K_LU)) && (vbReadPad()&(K_LL))) quincyanimtimer=0;
	if((vbReadPad()&(K_LU)) && (vbReadPad()&(K_LR))) quincyanimtimer=0;

 	if((vbReadPad()&(K_LU)) && (left>0) && (f==8)) f=0, up=0, down=0, quincyx=quincyx+2;
 	if((vbReadPad()&(K_LU)) && (right>0) && (f==8)) f=0, up=0, down=0, quincyx=quincyx-2;

 	if((vbReadPad()&(K_LU)) && (down==1) && (up==0) && (f==8)) f=0, up=1, down=0, quincyy=quincyy+4;	
	if((vbReadPad()&(K_LD)) && (f<8)) down=1, up=0, quincyanimtimer++;
	if((vbReadPad()&(K_LD)) && (up==1) && (f==8)) down=0; 
	

	
 	if((vbReadPad()&(K_LD)) && (left>0) && (f==8)) f=0, up=0, down=0, quincyx=quincyx+2;
 	if((vbReadPad()&(K_LD)) && (right>0) && (f==8)) f=0, up=0, down=0, quincyx=quincyx-2;


 	if((vbReadPad()&(K_LD)) && (up==1) && (down==0) && (f==8)) f=0, up=0, down=1, quincyy=quincyy-4;	
	if((vbReadPad()&(K_LU)) && (f<8)) up=1, down=0, quincyanimtimer++;
	if((vbReadPad()&(K_LU)) && (down==1) && (f==8)) up=0; 
	
	
 	if((vbReadPad()&(K_LR)) && (down>0) && (f==8)) f=0, left=0, right=0, quincyy=quincyy-4;
 	if((vbReadPad()&(K_LR)) && (up>0) && (f==8)) f=0, left=0, right=0, quincyy=quincyy+4;

 	if((vbReadPad()&(K_LR)) && (left==1) && (right==0) && (f==8)) f=0, left=0, right=1, quincyx=quincyx+2;	
	if((vbReadPad()&(K_LL)) && (f<8)) left=1, right=0, up=0, down=0, quincyanimtimer++;
	if((vbReadPad()&(K_LL)) && (right==1) && (f==8)) left=0; 	
	
	
 	if((vbReadPad()&(K_LL)) && (down>0) && (f==8)) f=0, right=0, left=0, quincyy=quincyy-4;
 	if((vbReadPad()&(K_LL)) && (up>0) && (f==8)) f=0, right=0, left=0, quincyy=quincyy+4;	


	if((vbReadPad()&(K_LL)) && (right==1) && (left==0) && (f==8)) f=0, right=0, left=1, quincyx=quincyx-2; 	
	if((vbReadPad()&(K_LR)) && (f<8)) left=0, right=1, up=0, down=0, quincyanimtimer++; 	
	if((vbReadPad()&(K_LR)) && (left==1) && (f==8)) right=0; 		



	vbSetWorld(29, WRLD_ON, quincyx, -2, quincyy, quincycutx, 0, 0, 14, 32);
	

	
	}
	
	
	}

	
	
	